﻿using System;
using System.Diagnostics;
using System.IO;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;

namespace Text_anchor
{
    public class text_anchors_rest
    {
        public static void Main(string[] args)
        {
            //replace api_key placeholder with your own value
            string apiKey = "api_key";
            string url = "https://sandbox.e-signlive.com/api";

            string jsonString = "{ \"roles\": [ { \"id\": \"client\", \"type\": \"SIGNER\", \"index\": 1, \"signers\": [ { \"firstName\": \"John\", \"lastName\": \"Smith\", \"email\": \"john.smith@example.com\" } ], \"name\": \"client\" }, { \"id\": \"contractor\", \"type\": \"SIGNER\", \"index\": 2, \"signers\": [ { \"firstName\": \"Bob\", \"lastName\": \"Murray\", \"email\": \"bob.murray@example.com\" } ], \"name\": \"contractor\" } ], \"documents\": [ { \"approvals\": [ { \"fields\": [ { \"type\": \"SIGNATURE\", \"extract\": false, \"extractAnchor\": { \"text\": \"Signature of the Client\", \"index\": 0, \"width\": 150, \"height\": 40, \"anchorPoint\": \"TOPLEFT\", \"characterIndex\": 0, \"leftOffset\": 0, \"topOffset\": -50 }, \"left\": 0, \"subtype\": \"FULLNAME\", \"top\": 0 }, { \"value\": null, \"type\": \"INPUT\", \"binding\": \"{signer.name}\", \"extract\": false, \"extractAnchor\": { \"text\": \"(hereafter referred to as\", \"index\": 0, \"width\": 150, \"height\": 20, \"anchorPoint\": \"TOPRIGHT\", \"characterIndex\": 0, \"leftOffset\": -175, \"topOffset\": -5 }, \"left\": 0, \"subtype\": \"LABEL\", \"top\": 0 }, { \"value\": null, \"type\": \"INPUT\", \"binding\": \"{approval.signed}\", \"extract\": false, \"extractAnchor\": { \"text\": \"Date\", \"index\": 0, \"width\": 75, \"height\": 40, \"anchorPoint\": \"TOPRIGHT\", \"characterIndex\": 4, \"leftOffset\": 10, \"topOffset\": -30 }, \"left\": 0, \"subtype\": \"LABEL\", \"top\": 0 } ], \"role\": \"client\" }, { \"fields\": [ { \"type\": \"SIGNATURE\", \"extract\": false, \"extractAnchor\": { \"text\": \"Signature of the Contractor\", \"index\": 0, \"width\": 150, \"height\": 40, \"anchorPoint\": \"TOPLEFT\", \"characterIndex\": 0, \"leftOffset\": 0, \"topOffset\": -50 }, \"left\": 0, \"subtype\": \"FULLNAME\", \"top\": 0 }, { \"value\": null, \"type\": \"INPUT\", \"binding\": \"{signer.name}\", \"extract\": false, \"extractAnchor\": { \"text\": \"(hereafter referred to as\", \"index\": 1, \"width\": 150, \"height\": 20, \"anchorPoint\": \"TOPRIGHT\", \"characterIndex\": 0, \"leftOffset\": -175, \"topOffset\": -5 }, \"left\": 0, \"subtype\": \"LABEL\", \"top\": 0 }, { \"value\": null, \"type\": \"INPUT\", \"binding\": \"{approval.signed}\", \"extract\": false, \"extractAnchor\": { \"text\": \"Date\", \"index\": 1, \"width\": 75, \"height\": 40, \"anchorPoint\": \"TOPRIGHT\", \"characterIndex\": 4, \"leftOffset\": 10, \"topOffset\": -30 }, \"left\": 0, \"subtype\": \"LABEL\", \"top\": 0 } ], \"role\": \"contractor\" } ], \"name\": \"Sample Contract\" } ], \"name\": \"Text Anchor Extraction Example REST API\", \"type\": \"PACKAGE\", \"language\": \"en\", \"autoComplete\": true, \"status\": \"DRAFT\" }";

            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            byte[] fileByteArray = File.ReadAllBytes("PATH_TO_YOUR_PDF.pdf");
            ByteArrayContent content = new ByteArrayContent(fileByteArray);

            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentDisposition.FileName = "\"NAME_OF_YOUR_FILE.pdf\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"", "\"NAME_OF_YOUR_FILE.pdf\"");
            form.Add(jsonContent, "\"payload\"");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri(url) + "/packages/", form).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
        }
    }
}
